//*****************************************************************************

//      Clase para almacenar funciones generales

//*****************************************************************************

package local.dialogos;

import java.awt.*;
import java.awt.event.*;


public  class OptDialogos extends Object
{
    static String s = "";

    //  Constructor

    public OptDialogos ()
    {
        super ();     //  Invoca al constructor de Object
    }

//===========================================================================

    //************      Funcin para introducir varios datos    *************

    public static String    optPreguntas (Frame parent, String pregTexto[],
                                         String respTexto[])
    {

        Font fuente = new Font ("Dialog", Font.BOLD, 12);

        class OptPreguntas extends Dialog
        {
            Label     pregunta[];
            TextField respuesta[]; 
            int       pregLines;
            int       numLetras = 0;
            int       ancho;
            Font      fuente;
            
        
            public OptPreguntas (Frame parent, String pregTexto[], 
                               String respTexto[])

            {
                super (parent, " ", true);
                setLayout (null);

                pregLines = pregTexto.length;
                int     j;


                for (int i = 0; i < pregLines; ++i)
                {
                    j = pregTexto[i].length ();
                    if (j > numLetras)
                        numLetras = j;
                }

                ancho = numLetras * 9;
                if (ancho < 130)
                    ancho = 130;


                        //  Crea referencias a "null"

                pregunta = new Label[pregLines];
                respuesta = new TextField[pregLines];


                    //  Construye objetos para las anteriores referencias
                    //  con el texto de la pregunta y la respuesta.
        
                for (int i = 0; i < pregLines; ++i)
                {
                    pregunta[i] = new Label (pregTexto[i]);
                    pregunta[i].setBounds (30, 40+i*40, ancho, 30);
                    //pregunta[i].setForeground (Color.blue);
		    this.add (pregunta[i]);

                    respuesta[i] = new TextField (respTexto[i], 10);
                    respuesta[i].setBounds (ancho+60, 40+i*40, 150, 30);
                    // respuesta[i].setForeground (Color.blue);
                    this.add (respuesta[i]);
                }

                    //  Construye los botones de control

                Button  aceptar = new Button ("D'acord");
                aceptar.addActionListener (new DialogHandler ());
                aceptar.setBounds (30, pregLines*40+50, 90, 30);
                // aceptar.setForeground (Color.blue);
				this.add (aceptar);

                Button  cancelar = new Button ("Cancel");
                cancelar.addActionListener (new DialogHandler ());
                cancelar.setBounds (ancho+20, pregLines*40+50, 90, 30);
                // cancelar.setForeground (Color.blue);
				this.add (cancelar);

            }

        

            class DialogHandler extends WindowAdapter implements ActionListener
            {
                public void actionPerformed (ActionEvent e)
                {
                    OptDialogos.s = e.getActionCommand ();
                    hide ();
                }
            }
        
        }

        OptPreguntas optPreguntas = new OptPreguntas (parent,
                              pregTexto, respTexto);


        int       pregLines = pregTexto.length;
        optPreguntas.setSize (optPreguntas.ancho+240, (pregLines+2)*40+20);
        optPreguntas.setFont (fuente);
        optPreguntas.setLocation (400, 100);
        optPreguntas.show ();

        if (OptDialogos.s == "D'acord")
        {
            for (int i = 0; i < pregLines; i ++)
            {
                respTexto[i] = optPreguntas.respuesta[i].getText ();
            }
        }

        return OptDialogos.s;
    }


//===========================================================================

    //*************      Funcin para preguntar Si o NO   *****************


    public static boolean    optPreguntaSiNo (Frame parent, String pregTexto)
    {

        Font fuente = new Font ("Dialog", Font.BOLD, 12);

        class OptPreguntaSiNo extends Dialog
        {

            int numLetras;
            int ancho;
        
            public OptPreguntaSiNo  (Frame parent, String pregTexto)

            {

                super (parent, " ", true);
                setLayout (null);

                numLetras = pregTexto.length ();
                ancho = numLetras * 9;
                if (ancho < 170)
                    ancho = 170;

                    //  Construye un objeto con el texto de la pregunta

                Label pregunta = new Label (pregTexto);
                pregunta.setBounds (30, 40, ancho, 30);
                //pregunta.setForeground (Color.blue);
				this.add (pregunta);

                    //  Construye los botones de control

                Button  aceptar = new Button ("Si");
                aceptar.addActionListener (new DialogHandler ());
                aceptar.setBounds (30, 90, 50, 30);
                //aceptar.setForeground (Color.blue);
				this.add (aceptar);

                Button  cancelar = new Button ("No");
                cancelar.addActionListener (new DialogHandler ());
                cancelar.setBounds (ancho-20, 90, 50, 30);
                //cancelar.setForeground (Color.blue);
				this.add (cancelar);

            }

            class DialogHandler extends WindowAdapter implements ActionListener
            {

                public void actionPerformed (ActionEvent e)
                {
                    OptDialogos.s = e.getActionCommand ();
                    hide ();
                }
            }
        
        }

        OptPreguntaSiNo optPreguntaSiNo = new OptPreguntaSiNo (parent, pregTexto);

        optPreguntaSiNo.setSize (optPreguntaSiNo.ancho+60, 140);
        optPreguntaSiNo.setFont (fuente);
        optPreguntaSiNo.setLocation (400, 100);
        optPreguntaSiNo.show ();

        if (OptDialogos.s == "Si")
            return true;
        else
            return false;
    }


//===========================================================================

    //*************      Funcin para escribir un mensaje breve  *****************


    public static void    optEscribeFlash (Frame parent, String pregTexto)
    {

        Font fuente = new Font ("Dialog", Font.BOLD, 12);

        class OptEscribeFlash extends Dialog
        {
            int numLetras;
            int ancho;
            
        
            public OptEscribeFlash  (Frame parent, String pregTexto)

            {
                super (parent, " ", true);
                setLayout (null);

                numLetras = pregTexto.length ();
                ancho = numLetras * 9;
                if (ancho < 100)
                    ancho = 100;

                addWindowListener (new WindowEventHandler ());

                    //  Construye un objeto con el texto del mensaje

                Label mensaje = new Label (pregTexto);
                mensaje.setBounds (50, 40, ancho, 30);
                //mensaje.setForeground (Color.blue);
				this.add (mensaje);


                    //  Construye un botn de control

                Button  aceptar = new Button ("D'acord");
                aceptar.addActionListener (new DialogHandler ());
                aceptar.setBounds (50, 90, 80, 30);
                //aceptar.setForeground (Color.blue);
				this.add (aceptar);


            }


            class WindowEventHandler extends WindowAdapter
            {
                public void windowClosing (WindowEvent e)
                {
                    hide (); 
                }
            }

            class DialogHandler extends WindowAdapter implements ActionListener
            {

                public void actionPerformed (ActionEvent e)
                {
                    OptDialogos.s = e.getActionCommand ();
                    hide ();
                }
            }
        }

        OptEscribeFlash optEscribeFlash = new OptEscribeFlash (parent, pregTexto);


        optEscribeFlash.setSize (optEscribeFlash.ancho+50, 160);
        optEscribeFlash.setFont (fuente);
        optEscribeFlash.setLocation (100, 100);
        optEscribeFlash.show ();

        for (int i = 0; i < 1000; i ++)
            Math.sqrt (i);

//        sleep (5);

        optEscribeFlash.hide ();
        return;
    }
}
